> ## Documentation Index > Fetch the complete documentation index at: https://support.tulip.co/llms.txt > Use this file to discover all available pages before exploring further. # /api/stations/v1/station-groups/{stationGroupId}/app-assignments/{appAssignmentId} > Updates a specific app assignment for a station group. ## OpenAPI ````json PUT /api/stations/v1/station-groups/{stationGroupId}/app-assignments/{appAssignmentId} { "openapi": "3.0.3", "info": { "title": "Tulip API", "version": "v1" }, "tags": [ { "name": "machines", "description": "An API for managing machines and their types" }, { "name": "stations", "description": "An API for managing and updating stations." }, { "name": "users", "description": "An API for managing users and their roles/permissions." } ], "paths": { "/api/stations/v1/station-groups/{stationGroupId}/app-assignments/{appAssignmentId}": { "put": { "operationId": "updateStationGroupAppAssignment", "description": "Updates a specific app assignment for a station group.", "tags": [ "stations" ], "x-tulip-visibility": "public", "requestBody": { "description": "The fields to update an app assignment.", "required": "true", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/GenericAppAssignment" } } } }, "parameters": [ { "name": "stationGroupId", "description": "The id of the station group to update.", "in": "path", "required": "true", "schema": { "$ref": "#/components/schemas/StationGroupId" } }, { "name": "appAssignmentId", "description": "The id of the app assignment to update.", "in": "path", "required": "true", "schema": { "$ref": "#/components/schemas/AppAssignmentId" } } ], "responses": { "200": { "description": "The app assignment was successfully updated.\n", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/AppAssignment" } } } }, "400": { "description": "An error occurred. The Tulip error codes `generic.customerIdRequired`, `generic.workspaceIdRequired`, `generic.invalidParams`, `http.invalidBodyJson`, `http.invalidHeaders`, and `http.multiValueHeader` all use the 400 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip customer context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.customerIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip workspace context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.workspaceIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request parameters were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.invalidParams" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request body could not be decoded as JSON.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidBodyJson" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request headers were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidHeaders" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An HTTP request header contained multiple values.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.multiValueHeader" ] }, "details": { "type": "object", "properties": { "headerName": { "description": "The name of the given HTTP header which had multiple values.\n", "type": "string" } }, "required": [ "headerName" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "401": { "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.authRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "404": { "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.notFound" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "409": { "description": "Conflicting app assignment detected. Only one app assignment can be specified for a specific app,\napp folder or all apps.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Conflicting app assignment detected. Only one app assignment can be specified for a specific app,\napp folder or all apps.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.conflictingAppAssignment" ] }, "details": { "type": "object", "properties": { "appAssignmentKind": { "type": "string" } }, "required": [ "appAssignmentKind" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "422": { "description": "An error occurred. The Tulip error codes `generic.archivedResourceUnsupportedOperation` and `stations.invalidReferencedResourceId` both use the 422 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "This operation is not permitted on the requested resource because it is archived.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.archivedResourceUnsupportedOperation" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "One or more ids referenced resources that were invalid. Please make sure\nall ids reference resources that exist.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.invalidReferencedResourceId" ] }, "details": { "type": "array", "description": "A list of invalid referenced resources.\n", "items": { "type": "object", "properties": { "resourceId": { "description": "The id of the invalid resource.\n", "type": "string" }, "details": { "description": "Details about why the resource was invalid.\n", "type": "string" } }, "required": [ "resourceId" ] } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "429": { "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.endpointRateLimitExceeded" ] }, "details": { "type": "object", "properties": { "details": { "description": "Additional details about this endpoint's rate limits.\n", "type": "string" } } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "500": { "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.internal" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } } } } } }, "components": { "schemas": { "GenericAppAssignment": { "type": "object", "description": "Represents the contents of a single app assignment.\n", "oneOf": [ { "$ref": "#/components/schemas/AllAppAssignment" }, { "$ref": "#/components/schemas/FolderAppAssignment" }, { "$ref": "#/components/schemas/SpecificAppAssignment" }, { "$ref": "#/components/schemas/VersionAppAssignment" } ], "discriminator": { "propertyName": "type", "mapping": { "all": "#/components/schemas/AllAppAssignment", "app-folder": "#/components/schemas/FolderAppAssignment", "app": "#/components/schemas/SpecificAppAssignment", "app-version": "#/components/schemas/VersionAppAssignment" } }, "example": { "type": "app", "tag": "development", "appId": "swM2aGebq5MjhKafN" } }, "StationGroupId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of a station group.\n" } ] }, "AppAssignmentId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app assignment.\n" } ] }, "AppAssignment": { "allOf": [ { "$ref": "#/components/schemas/GenericAppAssignment" }, { "type": "object", "description": "App assignments are added to stations and station groups to restrict what\napps are allowed to run at respective stations.\n", "properties": { "id": { "$ref": "#/components/schemas/AppAssignmentId" } }, "required": [ "id" ], "example": { "id": "12M2aGebq5MjhKafN", "type": "app", "tag": "development", "appId": "swM2aGebq5MjhKafN" } } ] }, "ApiError": { "description": "An error response returned by a Tulip API.\n", "type": "object", "properties": { "errorCode": { "description": "A machine-readable code identifying the type of error.\n", "type": "string", "pattern": "^[a-zA-Z0-9.]$" }, "message": { "description": "A human-readable description of the error intended for debugging purposes only.\n\nThe exact content of this message is not stable.\n", "type": "string" }, "retryable": { "description": "Whether the request can be automatically retried by the client.\n", "type": "boolean" } }, "required": [ "errorCode", "retryable" ] }, "AllAppAssignment": { "type": "object", "description": "Allows all apps to be assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "all", "enum": [ "all" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" } }, "required": [ "type", "tag" ], "example": { "type": "all", "tag": "development" } }, "FolderAppAssignment": { "type": "object", "description": "Describes a folder of apps that are assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "app-folder", "enum": [ "app-folder" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" }, "appFolderId": { "$ref": "#/components/schemas/AppFolderId" } }, "required": [ "type", "tag", "appFolderId" ], "example": { "type": "app-folder", "tag": "development", "appFolderId": "swM2aGebq5MjhKafN" } }, "SpecificAppAssignment": { "type": "object", "description": "Describes a specific app that is assigned to a station or station group.\n", "properties": { "type": { "type": "string", "default": "app", "enum": [ "app" ] }, "tag": { "$ref": "#/components/schemas/AppAssignmentTag" }, "appId": { "$ref": "#/components/schemas/AppId" } }, "required": [ "type", "tag", "appId" ], "example": { "type": "app", "tag": "development", "appId": "swM2aGebq5MjhKafN" } }, "VersionAppAssignment": { "type": "object", "description": "Describes a specific app version that is assigned to a station or station group. Only published\napp versions can be used in app assignments.\n", "properties": { "type": { "type": "string", "default": "app-version", "enum": [ "app-version" ] }, "appVersionId": { "$ref": "#/components/schemas/AppVersionId" }, "appId": { "$ref": "#/components/schemas/AppId" } }, "required": [ "type", "appVersionId", "appId" ], "example": { "type": "app-version", "appVersionId": "swM2aGebq5MjhKafN", "appId": "12M2aGebq5MjhKafN" } }, "RandomId": { "description": "A randomly generated unique identifier.\n\nTypically has ~98 bits of entropy.\n", "example": "g56RCoZCtzv7borvp", "type": "string", "pattern": "^[a-zA-Z0-9_]+$" }, "AppAssignmentTag": { "description": "The tag of an app assignment. Determines if the app assignment refers\nto the development version of an app or the latest production version.\n", "type": "string", "enum": [ "development", "latest-published" ] }, "AppFolderId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "A random string which uniquely identifies an app folder.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app folder.\n" } ] }, "AppId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The unique identifier for an app.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app.\n" } ] }, "AppVersionId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The unique identifier for an app version.\n" }, { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of an app version.\n" } ] } } } } ````